def find(f, seq):
    for s in seq:
        if f(s):
            return s
    raise LookupError

def find_index(f, seq):
    for i, s in enumerate(seq):
        if f(s):
            return i
    raise LookupError, 'hof.find_index(x): x not in sequence'

def find_indices(f, seq):
    indices = []
    for i, s in enumerate(seq):
        if f(s):
            indices.append(i)
    return indices

def all(f, seq):
    i = -1
    for i, s in enumerate(seq):
        if not f(s):
            return False
    if i < 0:
        return False
    else:
        return True

def any(f, seq):
    for s in seq:
        if f(s):
            return True
    return False

def take(f, seq):
    xs = []
    for x in seq:
        if f(x):
            xs.append(x)
        else:
            break
    return xs

def drop(f, seq):
    xs = []
    do = False
    for x in seq:
        if not do and not f(x):
            do = True
        if do:
            xs.append(x)
    return xs

def span(f, seq):
    return take(f, seq), drop(f, seq)

def partition(f, seq):
    xs = []
    nxs = []
    for x in seq:
        if f(x):
            xs.append(x)
        else:
            nxs.append(x)
    return xs, nxs
